.\" ** You probably do not want to edit this file directly **
.\" It was generated using the DocBook XSL Stylesheets (version 1.69.1).
.\" Instead of manually editing it, you probably should edit the DocBook XML
.\" source for it and then use the DocBook XSL Stylesheets to regenerate it.
.TH "KEYVAL2SH" "l" "" "" ""
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.SH "NAME"
keyval2sh \- Converts XML <keyval> files to bash command line arguments.
.SH "SYNOPSIS"
.HP 10
\fBkeyval2sh\fR [\fB\-n\fR\ \fITEXT\fR \fB\-\-name\fR\ \fITEXT\fR] [\fB\-d\fR\ \fITEXT\fR \fB\-\-doc\-type\fR\ \fITEXT\fR] [\fB\-t\fR\ \fItrue|false\fR \fB\-\-templates\fR\ \fItrue|false\fR] [\fB\-l\fR\ \fIFILENAME\fR \fB\-\-log\-file\fR\ \fIFILENAME\fR] [\fB\-\-install\-query\fR\ \fITEXT\fR] [\fB\-\-type\fR\ \fITEXT\fR]
.SH "DESCRIPTION"
.PP
The
\fBkeyval2sh\fR\fBbash\fR
shell script treats a <keyval> file as a specification for command line arguments. It can be used to provide the following services when building scripts:
.TP 3
\(bu
When used with just the
\-\-name NAME
argument, it will create up to SEVEN files, providing the developer with an initial starting point for creating a
\fBbash\fR
script with an associated man page.
.TP
\(bu
Subsequent invocations where
\-\-name NAME
is passed, will only cause the THREE files (\fINAME_config.sh\fR,
\fINAME_config.docbook_options\fR
and
\fINAME.docbook_synopsis\fR) to be generated.
.TP
\(bu
You as the developer will then replace the initial
\fINAME.sh\fR
created with the function you want to perform (you don't have to worry about the command line arguments as the code to handle this will be generated for you automatically).
.TP
\(bu
As a developer, you will then want to update the initial
\fINAME.docbook\fR
and
\fINAME_config.xml\fR
files (and possibly the
\fINAME.mk\fR
file) to correspond with your script's behavior.
.TP
\(bu
If you are working in a
\fBm4\fR
environment, you have the option of having
\fBm4\fR
man page support files generated for you.
.PP
A tutorial for using this script is available in the
[1]\&\fIxml\-keyval\fR
package document.
.SH "OPTIONS"
.PP
The following command line options are available:
.TP
[\fB\-n TEXT|\fR\fB\-\-name TEXT\fR]
This utility is designed to work with a set of files all having a root NAME. This option is used to specify the root NAME. This utility assumes that NAME_config.xml will be the source XML file. This utility can then generate NAME_config.sh, NAME_config.docbook_synopis, NAME_config.docbook_options, and NAME_config.sh_m4i. In addition, when templates have not been disabled, it will also generate NAME_config.xml, NAME.sh, NAME.mk, NAME.docbook and NAME.man.m4 if they don't exist.
.TP
[\fB\-d TEXT|\fR\fB\-\-doc\-type TEXT\fR]
This option allows one to specify what type of documentation files are to be produced. Use "none" if you don't want any documentation files. Use "docbook" to get a synopsis section and option section suitable for inclusion in a DocBook publication (used for creating man pages and HTML). Use
\fBm4\fR
to get a include file suitable for use in a
\fBm4\fR
based man page.
.TP
[\fB\-t true|false|\fR\fB\-\-templates true|false\fR]
This utility will stub in template files to get you off on the right foot with creating a new script. Unless you disable this feature, it will generate a template version of NAME_config.xml, NAME.sh, NAME.mk, and either NAME.docbook or NAME.man.m4 (however, this utility never replaces any of these initial files if they already exist).
.TP
[\fB\-l FILENAME|\fR\fB\-\-log\-file FILENAME\fR]
If you are encountering errors when running
\fBkeyval2sh\fR, try using this option and examine the log file after running
\fBkeyval2sh\fR. It may provide useful clues as to what went wrong.
.TP
[\fB\-\-install\-query TEXT\fR]
This option allows a user to specify options like
\-\-install xsl
to retrieve information about the package installation. This might be useful for making use of the package files outside of the packaged scripts.
\-\-install\-query help
will list all possible. The following choices are recognized:
help
\- lists what choices are available.
xsl
\- shows the directory the XSL files are stored under.
public\-id
\- displays the public ID of the keyval documents.
public\-url
\- displays the public URL of the keyval DTD.
dtd
\- shows the location of the keyval DTD file.
catalog
\- shows the location of the XML style catalog file.
catalog\-oasis
\- shows the location of the OASIS style catalog.
docs
\- shows local directory where the documents can be found.
url
\- shows the public URL where documenation can be found.
.TP
[\fB\-\-type TEXT\fR]
This option allows you to specify exactly one type of file to generate from your source
XML
file (by default, numerous files are generated). For example, if you just want the
\fINAME_config.sh\fR
file to be generated, you would specify
\-\-type sh. This function makes it easier to include this script in makefiles (or other scripts). Any of the following types are recognized:
docbook_options,
docbook_synopsis,
html,
sh
or
sh_m4i. NOTE: If you specify this option, templates will NOT be generated regardless of the
\-\-templates BOOL
setting.
.SH "FILES"
.TP
\fI/opt/VAIxml/share/vaisala/xml/keyval/dtd/keyval_1_0_0.dtd\fR
Location of the
DTD
which is used to validate the <keyval> document.
.TP
\fI/opt/VAIxml/share/vaisala/xml/keyval/xsl\fR
The directory containing the
[1]\&\fIXSL\fR
files used when translating <keyval> documents.
.TP
\fI/opt/VAIxml/share/doc/keyval\fR
The directory containing the package documentation (including a tutorial on using this utility).
.TP
\fI$HOME/tmp/vaisala/jars\fR
The directory where required
JAR
files will be stored if they need to be downloaded from the network.
.TP
\fI/var/vaisala/jars\fR
The system directory which is searched for required
JAR
files. System administrators may wish to copy the required
JAR
files to this location to prevent each user from downloading their own copy.
.TP
\fI/opt/VAIxml/share/vaisala/xml/keyval/xsl\fR
The directory containing the
[1]\&\fIXSL\fR
files used when translating <keyval> documents.
.SH "ENVIRONMENT"
.TP
\fBXML_COMMON_JAVA\fR
When translating
XML
documents with a
XSL
style sheet, the
\fBkeyval2sh\fR
will need access to a Java run time environment (v1.4.2 or later). If the
\fBjava\fR
interpreter found in your path is not version 1.4.2 or later, you can use this environment variable to specify the location of the appropriate
\fBjava\fR
interpreter. In addition, you can also use it to specify
HTTP
proxy information for your
\fBjava\fR
environment. For example, a setting of
/liz3/pkb/usr/j2re1.4.2_03/bin/java \-DproxyHost=172.26.0.232 \-DproxyPort=3128
would specify a path to a particular
\fBjava\fR
interpreter and set the
HTTP
proxy settings.
.TP
\fBXML_COMMON_CLASSPATH\fR
When translating
XML
documents with a
XSL
style sheet, the
\fBkeyval2sh\fR
require some
JAR
files which are not often found with a default
\fBjava\fR
installation. If these
JAR
files are not found in their expected locations, they will be automatically downloaded and placed in the
\fI${HOME}/tmp/vaisala/jars\fR
directory. However, this "automatic download as necessary" can be disabled if you manually set your
\fBXML_COMMON_CLASSPATH\fR.
.SH "AUTHORS"
.PP
Paul Blankenbaker created the initial script,
XSL
files, and build environment.
.SH "SEE ALSO"
.PP
\fBkeyval2cc\fR(l),
\fBkeyval2java\fR(l),
[1]\&\fIxml\-keyval\fR
package.
.SH "AUTHOR"
Paul Blankenbaker <paul@mekwin.com>. 
.SH "REFERENCES"
.TP 3
1.\ xml\-keyval
\%/VAIxml/keyval/index.html
.TP 3
2.\ XSL
\%http://www.w3.org/Style/XSL/
