<?xml version="1.0" ?> 
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="text" indent="no"/>
<xsl:strip-space elements="*"/>
<xsl:preserve-space elements="description"/>

<xsl:template match="/">

  <xsl:text>
<!--
  START:  DO NOT EDIT!

  AUTOMATICALLY GENERATED FROM XML USING keyval2sh_options.xsl
-->
&lt;refsect1&gt;&lt;title&gt;Options&lt;/title&gt;

&lt;para&gt;The following command line options are available:&lt;/para&gt;

&lt;variablelist&gt;
</xsl:text>

  <xsl:for-each select="keyval/*">

    <xsl:text>

  &lt;varlistentry&gt;

    &lt;term&gt;
      &lt;group choice="</xsl:text>

    <xsl:choose>
      <xsl:when test="@default = 'REQUIRED'">
        <xsl:text>plain</xsl:text>
      </xsl:when>

      <xsl:otherwise>
        <xsl:text>opt</xsl:text>
      </xsl:otherwise>

    </xsl:choose>

    <xsl:text>"&gt;
</xsl:text>

    <xsl:if test="key/@short">
      <xsl:text>        &lt;option&gt;-</xsl:text>
      <xsl:value-of select="key/@short"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="(@type)" />
      <xsl:text>|</xsl:text>
      <xsl:text>&lt;/option&gt;
</xsl:text>
    </xsl:if>

    <xsl:text>        &lt;option&gt;--</xsl:text>
    <xsl:value-of select="key"/>
    <xsl:text> </xsl:text>
    <xsl:value-of select="(@type)" />
    <xsl:text>&lt;/option&gt;
</xsl:text>

    <xsl:text>      &lt;/group&gt;
    &lt;/term&gt;

    &lt;listitem&gt;

      &lt;para&gt;</xsl:text>

    <xsl:apply-templates select="description"/>

    <xsl:if test="@min">
      <xsl:text> The minimum value permitted is </xsl:text>
      <xsl:value-of select="(@min)" />
      <xsl:text>.</xsl:text>
    </xsl:if>

    <xsl:if test="@max">
      <xsl:text> The maximum value permitted is </xsl:text>
      <xsl:value-of select="(@max)" />
      <xsl:text>.</xsl:text>
    </xsl:if>

    <xsl:text>&lt;/para&gt;

    &lt;/listitem&gt;

  &lt;/varlistentry&gt;</xsl:text>

  </xsl:for-each>

  <xsl:text>
&lt;/variablelist&gt;

&lt;/refsect1&gt;
<!--
  END:  DO NOT EDIT!

  AUTOMATICALLY GENERATED FROM XML USING keyval2sh_options.xsl
-->
</xsl:text>

</xsl:template>


<xsl:template match="description">
  <xsl:apply-templates/>
</xsl:template>

<xsl:template match="literal">
  <xsl:text>&lt;literal&gt;</xsl:text>
  <xsl:apply-templates/>
  <xsl:text>&lt;/literal&gt;</xsl:text>
</xsl:template>

<xsl:template match="application">
  <xsl:text>&lt;application&gt;</xsl:text>
  <xsl:apply-templates/>
  <xsl:text>&lt;/application&gt;</xsl:text>
</xsl:template>

<xsl:template match="command">
  <xsl:text>&lt;command&gt;</xsl:text>
  <xsl:apply-templates/>
  <xsl:text>&lt;/command&gt;</xsl:text>
</xsl:template>

<xsl:template match="acronym">
  <xsl:text>&lt;acronym&gt;</xsl:text>
  <xsl:apply-templates/>
  <xsl:text>&lt;/acronym&gt;</xsl:text>
</xsl:template>

<xsl:template match="filename">
  <xsl:text>&lt;filename&gt;</xsl:text>
  <xsl:apply-templates/>
  <xsl:text>&lt;/filename&gt;</xsl:text>
</xsl:template>

</xsl:stylesheet>
